# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 2.3.33.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from .rsection import RSection


class ModelEnvironmentDefinitionR(RSection):
    """Settings for a R environment.

    :param r_version: The version of R to be installed
    :type r_version: str
    :param user_managed: Indicates whether the environment is managed by user
     or by AzureML.
    :type user_managed: bool
    :param rscript_path: The Rscript path to use if an environment build is
     not required.
     The path specified gets used to call the user script.
    :type rscript_path: str
    :param snapshot_date: Date of MRAN snapshot to use in YYYY-MM-DD format,
     e.g. "2019-04-17"
    :type snapshot_date: str
    :param cran_packages: The CRAN packages to use.
    :type cran_packages: list[~_restclient.models.RCranPackage]
    :param git_hub_packages: The packages directly from GitHub.
    :type git_hub_packages: list[~_restclient.models.RGitHubPackage]
    :param custom_url_packages: The packages from custom urls.
    :type custom_url_packages: list[str]
    :param bio_conductor_packages: The packages from Bioconductor.
    :type bio_conductor_packages: list[str]
    """

    def __init__(self, r_version=None, user_managed=None, rscript_path=None, snapshot_date=None, cran_packages=None, git_hub_packages=None, custom_url_packages=None, bio_conductor_packages=None):
        super(ModelEnvironmentDefinitionR, self).__init__(r_version=r_version, user_managed=user_managed, rscript_path=rscript_path, snapshot_date=snapshot_date, cran_packages=cran_packages, git_hub_packages=git_hub_packages, custom_url_packages=custom_url_packages, bio_conductor_packages=bio_conductor_packages)
