# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 2.3.33.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class TargetRuntime(Model):
    """The target runtime.

    Variables are only populated by the server, and will be ignored when
    sending a request.

    :param target_architecture: The target architecture. Possible values
     include: 'Amd64', 'Arm32v7'
    :type target_architecture: str or ~_restclient.models.ArchitectureType
    :param os_type: The target operating system. Possible values include:
     'Linux', 'Windows'
    :type os_type: str or ~_restclient.models.OSType
    :param runtime_type: The target runtime type. Possible values include:
     'SparkPython', 'Python', 'PythonSlim', 'PythonCustom'
    :type runtime_type: str or ~_restclient.models.RuntimeType
    :ivar properties: The properties dictionary.
    :vartype properties: dict[str, str]
    """

    _validation = {
        'properties': {'readonly': True},
    }

    _attribute_map = {
        'target_architecture': {'key': 'targetArchitecture', 'type': 'ArchitectureType'},
        'os_type': {'key': 'osType', 'type': 'OSType'},
        'runtime_type': {'key': 'runtimeType', 'type': 'RuntimeType'},
        'properties': {'key': 'properties', 'type': '{str}'},
    }

    def __init__(self, target_architecture=None, os_type=None, runtime_type=None):
        super(TargetRuntime, self).__init__()
        self.target_architecture = target_architecture
        self.os_type = os_type
        self.runtime_type = runtime_type
        self.properties = None
